//
//  MembershipEditingPresenter.swift
//  SuperSpaManagement
//
//  Created by PHAM ANH TUAN on 3/21/21.
//  Copyright (c) 2021 ___ORGANIZATIONNAME___. All rights reserved.
//
//  This file was generated by the 🐍 VIPER generator
//

import Foundation
import RxSwift
import RxCocoa
import Resolver
import Action

protocol MembershipEditingWireframeInterface: WireframeInterface {
    func detachMembershipEditing()
}

protocol MembershipEditingViewInterface: ViewInterface {
    var viewModels: BehaviorRelay<[MembershipEditingCellType]> { get }
    var membership: BehaviorRelay<Membership?> { get }
}

final class MembershipEditingPresenter: MembershipEditingPresenterInterface {
    
    @LazyInjected var logger: Loggable
    // MARK: - Private properties -
    
    let addMembershipTrigger = PublishRelay<Membership>()
    
    private lazy var createMembershipAction = makeCreateMembershipAction()
    private lazy var updateMembershipAction = makeUpdateMembershipAction()
    private let disposeBag = DisposeBag()
    
    private unowned let view: MembershipEditingViewInterface
    private let interactor: MembershipEditingInteractorInterface
    private let wireframe: MembershipEditingWireframeInterface
    private let style: MembershipEditingStyle
    
    // MARK: - Lifecycle -
    
    init(view: MembershipEditingViewInterface, interactor: MembershipEditingInteractorInterface, wireframe: MembershipEditingWireframeInterface,style: MembershipEditingStyle) {
        self.view = view
        self.interactor = interactor
        self.wireframe = wireframe
        self.style = style
        
        configurePresenter()
        configureViewActions()
    }
}

// MARK: - Extensions -

extension MembershipEditingPresenter {
    private func configurePresenter() {
        
        switch style {
        case let .edit(membership):
            view.membership.accept(membership)
        default:
            break
        }
        
        Observable
            .just(
                MembershipEditingDataPresenter(style: self.style)
                    .joined()
            )
            .bind(to: view.viewModels)
            .disposed(by: disposeBag)
        
        Observable
            .merge(
                createMembershipAction.elements,
                updateMembershipAction.elements
            )
            .subscribeNext { [weak wireframe] in
                wireframe?.detachMembershipEditing()
            }
            .disposed(by: disposeBag)
    }
    
    private func configureViewActions() {
        addMembershipTrigger
            .subscribeNext { [weak self] membership in
                guard let self = self else { return }
                switch self.style {
                case .create:
                    self.createMembershipAction.execute(membership)
                    
                case let .edit(originalMembership):
                    var updateMembership = membership
                    updateMembership.id = originalMembership.id
                    self.updateMembershipAction.execute(updateMembership)
                }
            }
            .disposed(by: disposeBag)
    }
}

extension MembershipEditingPresenter {
    func makeCreateMembershipAction() -> Action<Membership, Void> {
        return Action<Membership, Void> { [unowned self] membership in
            return self.interactor.createMembership(membership)
        }
    }
    
    func makeUpdateMembershipAction() -> Action<Membership, Void> {
        return Action<Membership, Void> { [unowned self] membership in
            return self.interactor.updateMembership(membership)
        }
    }
}

struct MembershipEditingDataPresenter {
    
    let style: MembershipEditingStyle

    func joined() -> [MembershipEditingCellType] {
        
        switch style {
        case .create:
            return  [
                .chooseImage(title: "Chọn ảnh cho thành viên", initAssetId: ""),
                .info(title: "Tên thành viên", initTitle: "", style: .smallest, tag: .membershipName),
                .info(title: "Số điện thoại",initTitle: "", style: .smallest, tag: .membershipPhoneNumber),
                .info(title: "Địa chỉ",initTitle: "", style: .medium, tag: .membershipAddress),
                .add(title: "Thêm thành viên")
            ]
            
        case let .edit(membership):
            return  [
                .chooseImage(title: "Thay đổi ảnh cho thành viên", initAssetId: membership.avatarSavedAssetId),
                .info(title: "Đổi Tên thành viên", initTitle: membership.name, style: .smallest, tag: .membershipName),
                .info(title: "Đổi Số điện thoại",initTitle: membership.phoneNumber, style: .smallest, tag: .membershipPhoneNumber),
                .info(title: "Địa chỉ", initTitle: membership.address, style: .medium, tag: .membershipAddress),
                .add(title: "Cập nhật thông tin thành viên")
            ]
        }
    }
}
